<?php
/**
* @version 1.0
* @package ContentBuilder Image Scale
* @copyright (C) 2011 by Markus Bopp
* @license Released under the terms of the GNU General Public License
**/

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

jimport( 'joomla.plugin.plugin' );

class plgContentContentbuilder_video extends JPlugin {

    function __construct( &$subject, $params )
    {
        parent::__construct($subject, $params);
    }
    /**
     * Joomla 1.5 compatibility
     */
    function onPrepareContent(&$article, &$params, $limitstart = 0, $is_list = false, $form = null, $item = null )
    {
        $this->onContentPrepare('', $article, $params, $limitstart, $is_list, $form, $item);
    }

    function onContentPrepare($context, &$article, &$params, $limitstart = 0, $is_list = false, $form = null, $item = null) {
        
        $protect = false;
        
        $plugin = JPluginHelper::getPlugin('content', 'contentbuilder_video');
        jimport( 'joomla.html.parameter' );
	$pluginParams = new JParameter($plugin->params);
        
        jimport('joomla.filesystem.file');
        jimport('joomla.filesystem.folder');
        
        if(!JFile::exists(JPATH_SITE . DS . 'administrator' . DS . 'components' . DS . 'com_contentbuilder' . DS . 'classes' . DS . 'contentbuilder.php'))
        {
            return true;
        }
        
        $lang = JFactory::getLanguage();
        $lang->load('plg_content_contentbuilder_video', JPATH_ADMINISTRATOR);
        
        /*
         * As of Joomla! 1.6 there is just the text passed if the article data is not passed in article context.
         * (for instance with categories).
         * But we need the article id, so we use the article id flag from content generation.
         */
        if(is_object($article) && !isset($article->id) && !isset($article->cbrecord) && isset($article->text) && $article->text){
            preg_match_all("/<!--\(cbArticleId:(\d{1,})\)-->/si", $article->text, $matched_id);
            if(isset($matched_id[1]) && isset($matched_id[1][0])){
                $article->id = intval($matched_id[1][0]);
            }   
        }
        
        // if this content plugin has been called from within list context
        if($is_list){
            
            if(!trim($article->text)){
                return true;
            }
            
            $article->cbrecord = $form;
            $article->cbrecord->items = array();
            $article->cbrecord->items[0] = $item;
            $article->cbrecord->record_id = $item->colRecord;
            
        }
        
        if(!JFolder::exists(JPATH_SITE . DS . 'media' . DS . 'contentbuilder')) {
            JFolder::create(JPATH_SITE . DS . 'media' . DS . 'contentbuilder');
        }
        
        if(!JFile::exists(JPATH_SITE . DS . 'media' . DS . 'contentbuilder' . DS . 'index.html')) JFile::write(JPATH_SITE . DS . 'media' . DS . 'contentbuilder' . DS . 'index.html', $def = '');
        
        if(!JFolder::exists(JPATH_SITE . DS . 'media' . DS . 'contentbuilder' . DS . 'plugins')) {
            JFolder::create(JPATH_SITE . DS . 'media' . DS . 'contentbuilder' . DS . 'plugins');
        }
        
        if(!JFile::exists(JPATH_SITE . DS . 'media' . DS . 'contentbuilder' . DS . 'plugins' . DS . 'index.html')) JFile::write(JPATH_SITE . DS . 'media' . DS . 'contentbuilder' . DS . 'plugins' . DS . 'index.html', $def = '');
        
        if(!JFolder::exists(JPATH_SITE . DS . 'media' . DS . 'contentbuilder' . DS . 'plugins' . DS . 'video')) {
            JFolder::create(JPATH_SITE . DS . 'media' . DS . 'contentbuilder' . DS . 'plugins' . DS . 'video');
        }
        
        if(!JFile::exists(JPATH_SITE . DS . 'media' . DS . 'contentbuilder' . DS . 'plugins' . DS . 'video' . DS . 'index.html')) JFile::write(JPATH_SITE . DS . 'media' . DS . 'contentbuilder' . DS . 'plugins' . DS . 'video' . DS . 'index.html', $def = '');
        
        if(isset($article->id) || isset($article->cbrecord)){
            
            $db = JFactory::getDBO();
            
            $matches = array();
            
            preg_match_all("/\{CBVideo([^}]*)\}/i", $article->text, $matches);
            
            if(isset($matches[0]) && is_array($matches[0]) && isset($matches[1]) && is_array($matches[1])){
                
                $record = null;
                $default_title = '';
                $protect = 0;
                $form_id = 0;
                $record_id = 0;
                $type = '';
                
                $frontend = true;
                if (JFactory::getApplication()->isAdmin()) {
                    $frontend = false;
                }
                
                if (isset($article->id) && $article->id && !isset($article->cbrecord)) {

                    // try to obtain the record id if if this is just an article
                    $db->setQuery("Select form.`title_field`,form.`protect_upload_directory`,form.`reference_id`,article.`record_id`,article.`form_id`,form.`type`,form.`published_only`,form.`own_only`,form.`own_only_fe` From #__contentbuilder_articles As article, #__contentbuilder_forms As form Where form.`published` = 1 And form.id = article.`form_id` And article.`article_id` = " . $article->id);
                    $data = $db->loadAssoc();

                    require_once(JPATH_SITE . DS . 'administrator' . DS . 'components' . DS . 'com_contentbuilder' . DS . 'classes' . DS . 'contentbuilder.php');
                    $form = contentbuilder::getForm($data['type'], $data['reference_id']);
                    if(!$form || !$form->exists){
                        return true;
                    }
                    
                    if ($form) {
                        
                        $protect = $data['protect_upload_directory'];
                        $record = $form->getRecord($data['record_id'], $data['published_only'], $frontend ? ( $data['own_only_fe'] ? JFactory::getUser()->get('id', 0) : -1 ) : ( $data['own_only'] ? JFactory::getUser()->get('id', 0) : -1 ), true );
                        $default_title = $data['title_field'];
                        $form_id = $data['form_id'];
                        $record_id = $data['record_id'];
                        $type = $data['type'];
                    }
                    
                } else if (isset($article->cbrecord) && isset($article->cbrecord->id) && $article->cbrecord->id) {
                    
                    $protect = $article->cbrecord->protect_upload_directory;
                    $record = $article->cbrecord->items;
                    $default_title = $article->cbrecord->title_field;
                    $form_id = $article->cbrecord->id;
                    $record_id = $article->cbrecord->record_id;
                    $type = $article->cbrecord->type;
                    
                }
                
                if(!trim($default_title)){
                    $default_title = strtotime('now');
                }

                $i = 0;
                foreach($matches[1] As $match){
                    
                    $out =  '';
                    $field  = $is_list ? $article->cbrecord->items[0]->recName : '';
                    $type   = 'auto';
                    $width  = 300;
                    $height = 200;
                    $template = 'fallback';
                    $title = 'ContentBuilder Video Plugin';         
                    $show_error = false;
                    $check_id = false;
                    $player_image = '';
                    $player_autostart = false;
                    $player_bgcolor = '000000';
                    $player_controlbar = 'bottom';
                    $player_skin = 'whotube';
                    $player_base = null;
                    $player_uploaded = false;
                    
                    $options = explode(';', trim($match));
                    foreach($options As $option){
                        $keyval = explode(':',trim($option), 2);
                        if(count($keyval) == 2){
                            
                            $value = trim($keyval[1]);
                            switch(strtolower(trim($keyval[0]))){
                                case 'field':
                                    $field = $is_list ? $article->cbrecord->items[0]->recName : $value;
                                    break;
                                case 'type':
                                    $type = $value;
                                    break;
                                case 'width':
                                    $width = $value;
                                    break;
                                case 'height':
                                    $height = $value;
                                    break;
                                case 'template':
                                    $template = JFile::exists(JPATH_SITE . DS . $value) ? JPATH_SITE . DS . $value : 'fallback';
                                    break;
                                case 'title':
                                    $title = $value;
                                    break;
                                case 'show-error':
                                    $show_error = strtolower($value) == 'true' ? true : false;
                                    break;
                                case 'check-id':
                                    $check_id = strtolower($value) == 'true' ? true : false;
                                    break;
                                case 'player-image':
                                    $player_image = $value;
                                    break;
                                case 'player-autostart':
                                    $player_autostart = strtolower($value) == 'true' ? true : false;
                                    break;
                                case 'player-bgcolor':
                                    $player_bgcolor = $value;
                                    break;
                                case 'player-controlbar':
                                    $player_controlbar = $value;
                                    break;
                                case 'player-skin':
                                    $player_skin = $value;
                                    break;
                                case 'player-base':
                                    $player_base = $value;
                                    break;
                                case 'player-uploaded':
                                    $player_uploaded = strtolower($value) == 'true' ? true : false;
                                    break;
                            }
                        }
                    }
                    
                    $template_out = '';
                    
                    if ($field && isset($record) && $record !== null && is_array($record)) {

                       foreach ($record As $item){
                           if( $default_title == $item->recElementId ){
                            $default_title = $item->recValue;
                            break;
                           }
                       }

                       foreach ($record As $item){

                           if($item->recName == $field){

                                $value = trim($item->recValue);
                                
                                // in case it is a multi upload, for now we only accept one video (the first)
                                $value = explode("\n",$value);
                                $value = $value[0];
                                
                                switch(strtolower($type)){
                                    case 'auto':
                                        if(substr(strtolower($value), 0, 4) != "http") {
                                            $value = 'http://'.$value;
                                        }
                                        $parsed = @parse_url( $value );
                                        if($parsed !== false && isset($parsed['host'])){
                                            switch(strtolower($parsed['host'])){
                                                case 'www.youtube.com':
                                                case 'youtube.com':
                                                case 'youtu.be':
                                                case 'www.youtu.be':
                                                    $template_out = $this->getYoutubeTemplate($value, $title, $template, $width, $height, $check_id);
                                                    break;
                                                case 'vimeo.com':
                                                case 'www.vimeo.com':
                                                case 'player.vimeo.com':
                                                    $template_out = $this->getVimeoTemplate($value, $title, $template, $width, $height, $check_id);
                                                    break;
                                                case 'dailymotion.com':
                                                case 'www.dailymotion.com':
                                                    $template_out = $this->getDailymotionTemplate($value, $title, $template, $width, $height, $check_id);
                                                    break;
                                            }
                                        }
                                        
                                        break;
                                    case 'youtube':
                                    case 'youtube_id':
                                        if(strtolower($type) == 'youtube_id'){
                                            $value = 'http://www.youtube.com/watch?v='.$value;
                                        }
                                        else{
                                            if(substr(strtolower($value), 0, 4) != "http") {
                                                $value = 'http://'.$value;
                                            }
                                        }
                                        $template_out = $this->getYoutubeTemplate($value, $title, $template, $width, $height, $check_id);
                                        break;
                                    case 'vimeo':
                                    case 'vimeo_id':
                                        if(strtolower($type) == 'vimeo_id'){
                                            $value = 'http://vimeo.com/'.$value;
                                        }
                                        else{
                                            if(substr(strtolower($value), 0, 4) != "http") {
                                                $value = 'http://'.$value;
                                            }
                                        }
                                        $template_out = $this->getVimeoTemplate($value, $title, $template, $width, $height, $check_id);
                                        break;
                                    case 'dailymotion':
                                    case 'dailymotion_id':
                                        if(strtolower($type) == 'dailymotion_id'){
                                            $value = 'http://www.dailymotion.com/video/'.$value;
                                        }
                                        else{
                                            if(substr(strtolower($value), 0, 4) != "http") {
                                                $value = 'http://'.$value;
                                            }
                                        }
                                        $template_out = $this->getDailymotionTemplate($value, $title, $template, $width, $height, $check_id);
                                        break;
                                    case 'local_player':
                                        $template_out = 
                                            $this->getLocalPlayerTemplate(
                                              $value, 
                                              $player_image, 
                                              $player_autostart, 
                                              $player_bgcolor, 
                                              $player_controlbar, 
                                              $player_skin,
                                              $player_base,
                                              $player_uploaded,
                                              $title, 
                                              $width, 
                                              $height
                                            );
                                        break;
                                }
                                
                                break;
                           }
                       }
                    }
                    
                    if(!$template_out && $show_error){
                        $template_out = '<span class="cbVideoError" style="color:red">'.JText::_('COM_CONTENTBUILDER_PLUGINS_VIDEO_ERROR').'</span>';
                    }
                    
                    $article->text = str_replace($matches[0][$i], $template_out, $article->text);
        
                    $i++;
                }
            }
        }

	return true;
    }
    
    static function loadLocalPlayerJs(){
        static $loaded;
        
        if(!$loaded){
            
            jimport('joomla.version');
            $version = new JVersion();
            
            if(JRequest::getCmd('format') == 'html' || JRequest::getCmd('format') == ''){
                $plg_path = JURI::root(true).'/plugins/content/contentbuilder_video';
                if(version_compare($version->getShortVersion(), '1.6', '<')){
                    $plg_path = JURI::root(true).'/plugins/content';
                }
                JFactory::getDocument()->addScript($plg_path.'/contentbuilder_video_folder/jwplayer/jwplayer.js');
            }
            
            $loaded = true;
        }
    }
    
    static function loadLocalPlayerCss(){
        static $loaded;
        
        if(!$loaded){
            if(JRequest::getCmd('format') == 'html' || JRequest::getCmd('format') == ''){
                JFactory::getDocument()->addStyleDeclaration('* focus,object,player{outline:none}');
            }
            $loaded = true;
        } 
    }
    
    function getLocalPlayerTemplate($value, $image, $autostart, $bgcolor, $controlbar, $skin, $base, $uploaded, $title, $width, $height){
        
        jimport('joomla.filesystem.file');
        jimport('joomla.version');
        
        $version = new JVersion();
        $ext = JFile::getExt(basename($value));
        
        if(!trim($value) || !in_array(strtolower($ext), array('flv','mp4','ogv','webm','f4v','m4v','3gp','3g2','mp3','aac','m4a','ogg'))){
           return ''; 
        }
        
        self::loadLocalPlayerJs();
        self::loadLocalPlayerCss();
        
        $plg_path = JURI::root(true).'/plugins/content/contentbuilder_video';
        if(version_compare($version->getShortVersion(), '1.6', '<')){
            $plg_path = JURI::root(true).'/plugins/content';
        }
        
        if($uploaded){
            $realpath = realpath($value);
            $value = JURI::root(true).str_replace("\\","/",substr($realpath, strlen(JPATH_SITE)));
        }
        
        $id = md5($value.  mt_rand(0, mt_getrandmax()));
        
        return "<div id=\"cbVideo_".$id."\" style=\"width:".intval($width)."px;height:".intval($height)."px;\" title=\"".$title."\"></div>
        <script type=\"text/javascript\">
                jwplayer('cbVideo_".$id."').setup({
                        'file': '".($base !== null && !$uploaded ? JURI::root(true).'/'.rtrim($base,'/') . '/' : '') . $value."',
                        'image': '".$image."',
                        'height': '".intval($height)."',
                        'width': '".intval($width)."',
                        'modes': [
                                { 'type': 'html5' },
                          { 'type': 'flash', src: '".$plg_path."/contentbuilder_video_folder/jwplayer/player.swf' },
                          { 'type': 'download' }
                        ],
                        'autostart': '".$autostart."',
                        'backcolor': '".$bgcolor."',
                        'plugins': {
                                'viral-2': {
                                        'onpause': 'false',
                                        'oncomplete': 'true'
                                }
                        },
                        'controlbar': '".$controlbar."',
                        'skin': '".$plg_path."/contentbuilder_video_folder/jwplayer/skins/".$skin."/".$skin.".zip'
                });
        </script>";
    }
    
    static function loadTemplateCss($style){
        static $loaded;
        
        if(!$loaded){
            if(JRequest::getCmd('format') == 'html' || JRequest::getCmd('format') == ''){
                JFactory::getDocument()->addStyleDeclaration($style);
            }
            $loaded = true;
        }
    }
    
    function getTemplate($path, $id, $embed, $width){
       ob_start();
       require_once($path);
       $c = ob_get_contents();
       ob_end_clean();
       return $c;
    }
    
    /**
     * DAILYMOTION
     */
    
    function getDailymotionTemplate($value, $title, $template, $width, $height, $check_id){
        $template_out = '';
        $id = $this->getDailymotionId($value);
        if(!$check_id || $this->isDailymotionId($id)){
           $embed = '<iframe src="http://www.dailymotion.com/embed/video/'.basename($value).'" width="'.$width.'" height="'.$height.'" frameborder="0" title="'.$title.'"></iframe>';
           if($template == 'fallback'){
               $template_out = $embed;
           } else {
               $template_out = $this->getTemplate($template, 'cbDailymotion'.$id, $embed, $width);
           }
        }
        return $template_out;
    }
    
    function isDailymotionId($id){
        
        if ( !function_exists('curl_init') ) {
            if(!$id){
                return false;
            }
            return true;
        }
        
        if(!$id){
            return false;
        }

        $curl = @curl_init("https://dailymotion.com/");
        @curl_setopt($curl, CURLOPT_NOBODY, TRUE);
        @curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
        @curl_exec($curl);
        $res = @curl_errno($curl);

        if($res == 0)
        {
          $info = @curl_getinfo($curl);
          if($info['http_code'] == 200 || $info['http_code'] == 301)
          {
            $headers = @get_headers("https://api.dailymotion.com/video/".$id);
            if (isset($headers[0]) && !strpos($headers[0], '200')) {
                return false;
            }
          }
        }

        return true;
    }
    
    function getDailymotionId($text) {
        $id = strtok(basename($text), '_');

        if($id !== false) return $id;
        return '';
    }
    
    /**
     * VIMEO
     */
    
    function getVimeoTemplate($value, $title, $template, $width, $height, $check_id){
        $template_out = '';
        $vimeoId = $this->getVimeoId($value);
        if(!$check_id || $this->isVimeoId($vimeoId)){
           $embed = '<iframe src="http://player.vimeo.com/video/'.$vimeoId.'?portrait=0" width="'.$width.'" height="'.$height.'" frameborder="0" title="'.$title.'"></iframe>';
           if($template == 'fallback'){
               $template_out = $embed;
           } else {
               $template_out = $this->getTemplate($template, 'cbVimeo'.$vimeoId, $embed, $width);
           }
        }
        return $template_out;
    }
    
    function isVimeoId($vimeoId){
        // Check if vimeo video item exists by the existance of the the 200 response
        $headers = @get_headers('http://vimeo.com/api/v2/video/' . $vimeoId . '.xml');
        if (isset($headers[0]) && !strpos($headers[0], '200')) {
            return false;
        }
        return true;
    }
    
    function getVimeoId($text) {
        $id = '';
        $vimeo = $text;
        //try new embed code
        preg_match("/http:\/\/player.vimeo.com\/video\/([^?\"]*)/is", $vimeo, $match);
        if(!empty($match))
        {
            //found id
            $id = $match[1];
        }
        else
        {
            //try old embed code
            preg_match("/http:\/\/[w.]*vimeo.com\/moogaloop.swf?clip_id=([^&\"]*)/is", 
                    $vimeo, $match);
            if(!empty($match))
            {
                //found id
                $id = $match[1];
            }
            else
            {
                //try url
                preg_match("/http:\/\/[w.]*vimeo.com\/([^&\"]*)/is", 
                    $vimeo, $match);
                if(!empty($match))
                {
                    //found id
                    $id = $match[1];
                }
            }
        }
        return $id;
    }
    
    /**
     * YOUTUBE
     */
    
    function getYoutubeTemplate($value, $title, $template, $width, $height, $check_id){
        $template_out = '';
        $youtubeId = $this->getYoutubeId($value);
        if(!$check_id || $this->isYoutubeId($youtubeId)){
           $embed = '<iframe src="http://www.youtube.com/embed/'.$youtubeId.'" width="'.$width.'" height="'.$height.'" frameborder="0" allowfullscreen title="'.$title.'"></iframe>';
           if($template == 'fallback'){
               $template_out = $embed;
           } else {
               $template_out = $this->getTemplate($template, 'cbYoutube'.$youtubeId, $embed, $width);
           }
        }
        return $template_out;
    }
    
    function isYoutubeId($youtubeId){
        // Check if youtube video item exists by the existance of the the 200 response
        $headers = @get_headers('http://gdata.youtube.com/feeds/api/videos/' . $youtubeId);
        if (isset($headers[0]) && !strpos($headers[0], '200')) {
            return false;
        }
        return true;
    }
    
    function getYoutubeId($text) {
        $text = preg_replace('~
            # Match non-linked youtube URL in the wild. (Rev:20111012)
            https?://         # Required scheme. Either http or https.
            (?:[0-9A-Z-]+\.)? # Optional subdomain.
            (?:               # Group host alternatives.
              youtu\.be/      # Either youtu.be,
            | youtube\.com    # or youtube.com followed by
              \S*             # Allow anything up to VIDEO_ID,
              [^\w\-\s]       # but char before ID is non-ID char.
            )                 # End host alternatives.
            ([\w\-]{11})      # $1: VIDEO_ID is exactly 11 chars.
            (?=[^\w\-]|$)     # Assert next char is non-ID or EOS.
            (?!               # Assert URL is not pre-linked.
              [?=&+%\w]*      # Allow URL (query) remainder.
              (?:             # Group pre-linked alternatives.
                [\'"][^<>]*>  # Either inside a start tag,
              | </a>          # or inside <a> element text contents.
              )               # End recognized pre-linked alts.
            )                 # End negative lookahead assertion.
            [?=&+%\w]*        # Consume any URL (query) remainder.
            ~ix', 
            '$1',
            $text);
        return $text;
    }
}